LeetCode 题解(93): Longest Consecutive Sequence

2024-05-28 09:18

本文主要是介绍LeetCode 题解(93): Longest Consecutive Sequence,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

题目:

Given an unsorted array of integers, find the length of the longest consecutive elements sequence.

For example,
Given [100, 4, 200, 1, 3, 2],
The longest consecutive elements sequence is [1, 2, 3, 4]. Return its length: 4.

Your algorithm should run in O(n) complexity.

题解:

因为O(n)时间,所以不能排序。用set或map保存nums的值,然后取set或map中的一个元素,从set或map中删除当前元素并查看该元素+1,该元素-1是否在set或map中,如果在就增加currentLongest,并相应的删除该元素+1,该元素-1。以此类推。

c++版:

class Solution {
public:int longestConsecutive(vector<int>& nums) {unordered_set<int> exist;for(auto i : nums)exist.insert(i);int longest = 0;while(exist.size() != 0) {int current = *exist.begin();exist.erase(exist.begin());int currentLongest = 1;int j = 1;if(current + j < INT_MAX && exist.find(current + j) != exist.end()) {while(exist.find(current + j) != exist.end()) {currentLongest++;exist.erase(current+j);j++;}}j = 1;if(current - j > INT_MIN && exist.find(current - j) != exist.end()) {while(exist.find(current - j) != exist.end()) {currentLongest++;exist.erase(current - j);j++;}}if(currentLongest > longest)longest = currentLongest;}return longest;}
};

Java版:

public class Solution {public int longestConsecutive(int[] nums) {Set<Integer> exist = new HashSet<>();for(int i : nums)exist.add(i);int longest = 0;while(exist.isEmpty() == false) {Iterator<Integer> iter = exist.iterator();if(iter.hasNext()) {int current = iter.next();exist.remove(current);int currentLongest = 1;int j = 1;if(current + j <= Integer.MAX_VALUE && exist.contains(current+j)) {while(exist.contains(current+j)) {currentLongest++;exist.remove(current+j);j++;}}j = 1;if(current - j >= Integer.MIN_VALUE && exist.contains(current-j)) {while(exist.contains(current-j)) {currentLongest++;exist.remove(current-j);j++;}}if(currentLongest > longest) {longest = currentLongest;}}}return longest;}
}

Python版:

class Solution:# @param {integer[]} nums# @return {integer}def longestConsecutive(self, nums):exist = set()for i in nums:exist.add(i)longest = 1while len(exist) != 0:current = exist.pop()currentLongest = 1j = 1while current + j in exist:currentLongest += 1exist.remove(current + j)j += 1j = 1while current - j in exist:currentLongest += 1exist.remove(current - j)j += 1if currentLongest > longest:longest = currentLongestreturn longest


这篇关于LeetCode 题解(93): Longest Consecutive Sequence的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/1010149

相关文章

哈希leetcode-1

目录 1前言 2.例题  2.1两数之和 2.2判断是否互为字符重排 2.3存在重复元素1 2.4存在重复元素2 2.5字母异位词分组 1前言 哈希表主要是适合于快速查找某个元素(O(1)) 当我们要频繁的查找某个元素,第一哈希表O(1),第二,二分O(log n) 一般可以分为语言自带的容器哈希和用数组模拟的简易哈希。 最简单的比如数组模拟字符存储,只要开26个c

leetcode-24Swap Nodes in Pairs

带头结点。 /*** Definition for singly-linked list.* public class ListNode {* int val;* ListNode next;* ListNode(int x) { val = x; }* }*/public class Solution {public ListNode swapPairs(L

leetcode-23Merge k Sorted Lists

带头结点。 /*** Definition for singly-linked list.* public class ListNode {* int val;* ListNode next;* ListNode(int x) { val = x; }* }*/public class Solution {public ListNode mergeKLists

C++ | Leetcode C++题解之第393题UTF-8编码验证

题目: 题解: class Solution {public:static const int MASK1 = 1 << 7;static const int MASK2 = (1 << 7) + (1 << 6);bool isValid(int num) {return (num & MASK2) == MASK1;}int getBytes(int num) {if ((num &

【每日一题】LeetCode 2181.合并零之间的节点(链表、模拟)

【每日一题】LeetCode 2181.合并零之间的节点(链表、模拟) 题目描述 给定一个链表,链表中的每个节点代表一个整数。链表中的整数由 0 分隔开,表示不同的区间。链表的开始和结束节点的值都为 0。任务是将每两个相邻的 0 之间的所有节点合并成一个节点,新节点的值为原区间内所有节点值的和。合并后,需要移除所有的 0,并返回修改后的链表头节点。 思路分析 初始化:创建一个虚拟头节点

C语言 | Leetcode C语言题解之第393题UTF-8编码验证

题目: 题解: static const int MASK1 = 1 << 7;static const int MASK2 = (1 << 7) + (1 << 6);bool isValid(int num) {return (num & MASK2) == MASK1;}int getBytes(int num) {if ((num & MASK1) == 0) {return

计蒜客 Half-consecutive Numbers 暴力打表找规律

The numbers 11, 33, 66, 1010, 1515, 2121, 2828, 3636, 4545 and t_i=\frac{1}{2}i(i+1)t​i​​=​2​​1​​i(i+1), are called half-consecutive. For given NN, find the smallest rr which is no smaller than NN

【JavaScript】LeetCode:16-20

文章目录 16 无重复字符的最长字串17 找到字符串中所有字母异位词18 和为K的子数组19 滑动窗口最大值20 最小覆盖字串 16 无重复字符的最长字串 滑动窗口 + 哈希表这里用哈希集合Set()实现。左指针i,右指针j,从头遍历数组,若j指针指向的元素不在set中,则加入该元素,否则更新结果res,删除集合中i指针指向的元素,进入下一轮循环。 /*** @param

C - Word Ladder题解

C - Word Ladder 题解 解题思路: 先输入两个字符串S 和t 然后在S和T中寻找有多少个字符不同的个数(也就是需要变换多少次) 开始替换时: tips: 字符串下标以0开始 我们定义两个变量a和b,用于记录当前遍历到的字符 首先是判断:如果这时a已经==b了,那么就跳过,不用管; 如果a大于b的话:那么我们就让s中的第i项替换成b,接着就直接输出S就行了。 这样

LeetCode:64. 最大正方形 动态规划 时间复杂度O(nm)

64. 最大正方形 题目链接 题目描述 给定一个由 0 和 1 组成的二维矩阵,找出只包含 1 的最大正方形,并返回其面积。 示例1: 输入: 1 0 1 0 01 0 1 1 11 1 1 1 11 0 0 1 0输出: 4 示例2: 输入: 0 1 1 0 01 1 1 1 11 1 1 1 11 1 1 1 1输出: 9 解题思路 这道题的思路是使用动态规划